###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2006 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################

# NOTE: This file should be built in lock-step with RHEL5 kernel releases.
#       Please contact Jon Masters or Chris Feist for further information.

Source10: kmodtool_gfs2
%define kmodtool bash %{SOURCE10}
%{!?kversion: %define kversion 2.6.18-92.el5}

%define kmod_name gfs2
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%ifarch i686 x86_64 ia64
%define xenvar xen
%endif

%ifarch ppc64
%define kdumpvar kdump
%endif

%ifarch i686
%define PAEvar PAE
%endif

%define upvar ""
%{!?kvariants: %define kvariants %{?upvar} %{?xenvar} %{?kdumpcar} %{?PAEvar}}

Name:           %{kmod_name}-kmod
Version:        1.92
Release:        1.1%{?dist}.2
Summary:        %{kmod_name} kernel module
Group:          System Environment/Kernel
License:        GPL
URL:            http://www.redhat.com/
Source0:        gfs2-%{version}.tar.gz
Source1:	gfs2.conf
Patch0:		gfs2-kmod-overlay.patch
Patch1:		bz345401.patch
Patch2:		bz432057-comment115.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686 x86_64 ppc64 ia64 s390x

%description
GFS2 - The GFS2 filesystem provided for RHEL5.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
%patch0 -p1 -b .overlay
%patch1 -p2 -b .bz345401
%patch2 -p2 -b .bz432057-comment115

for kvariant in %{kvariants} ; do
    cp -a gfs2 _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules M=$PWD
    popd
done


%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{kmod_name}
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules_install M=$PWD
    popd
done
# The redhat-rpm-config strip/debuginfo scripts need these executable or the
# resultant debuginfo package will be empty.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

mkdir -p $RPM_BUILD_ROOT/etc/depmod.d/
cp -a $RPM_SOURCE_DIR/gfs2.conf $RPM_BUILD_ROOT/etc/depmod.d/

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed May 22 2008 Chris Feist <cfeist@redhat.com> - 1.92-1.1.el5_2.2
- d_doio no longer gets stuck in readv waiting for a pagelock.
- Resolves: rhbz#447944

* Wed Apr 30 2008 Chris Feist <cfeist@redhat.com> - 1.92
- Resynced to -92 kernel.

* Wed Oct 10 2007 Chris Feist <cfeist@redhat.com> - 1.16
- Rebuild for -53 kernel.
- Fixed a race condition caused when multiple glock demote requests were sent
  to a node back-to-back.
- Related: rhbz#267001

* Tue Oct 02 2007 Chris Feist <cfeist@redhat.com> - 1.15
- We now look in the proper place for gfs2.ko
- Resolves: rhbz#315411

* Mon Oct 01 2007 Chris Feist <cfeist@redhat.com> - 1.14
- Fix error during anaconda installation.
- Resolves: rhbz#313761

* Thu Sep 27 2007 Chris Feist <cfeist@redhat.com> - 1.13
- Rebuild for -52 kernel.
- Related: #282921

* Tue Sep 25 2007 Chris Feist <cfeist@redhat.com> - 1.12
- Rebuild for -51 kernel.
- Related: #282921

* Tue Sep 25 2007 Chris Feist <cfeist@redhat.com> - 1.11
- Rebuild for -50 kernel.
- Related: #282921

* Tue Sep 25 2007 Jon Masters <jcm@redhat.com> - 1.10
- Make the .ko files inode entries marked as "executable" for debuginfo.
- Bump kernel revision to -48 while we're at it.
- Related: #282921

* Mon Sep 17 2007 Jon Masters <jcm@redhat.com> - 1.7
- Rebuild against RHEL5 kernel -47 and disable automatic overrides.
- Related: #282921

* Sat Sep 08 2007 Jon Masters <jcm@redhat.com> - 1.6
- Initial internal release of the GFS2 filesystem for RHEL5.
- Related: #282921
